# MCMC implementation using the Metropolis-Hastings Algorithm

import numpy as np

def target(theta):
    return 1/(1+np.power(theta,2))/np.pi

b=10; # variance of the proposal Gaussian density

niters = 1000
naccept = 0

theta = 0 # initial value for the Markov chain

samples = np.zeros(niters+1)
samples[0] = theta
for i in range(niters):
    theta_p = theta + np.random.randn()*b;
    rho = min(1, target(theta_p)/target(theta ))
    u = np.random.uniform()
    if u < rho:
        naccept += 1
        theta = theta_p
    samples[i+1] = theta
